// gtkmozembed_crash.cpp : Defines the entry point for the console application.
//

#include <tchar.h>
#include <gtk/gtk.h>
#include <gtkmozembed.h>

void create_new_tab(GtkWidget *, char *);

gboolean close_eventhandler(GtkWidget *caller, gpointer data)
{
    gtk_widget_destroy(GTK_WIDGET(data));

    return FALSE;
}

int _tmain(int argc, _TCHAR* argv[])
{
    GtkWidget *window;
    GtkWidget *notebook;

    gtk_set_locale ();
    gtk_init (&argc, &argv);

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_show(window);

    notebook = gtk_notebook_new();
    gtk_container_add(GTK_CONTAINER(window), notebook);
    gtk_widget_show(notebook);

    create_new_tab(notebook, "Tab 1");
    create_new_tab(notebook, "Tab 2");
    create_new_tab(notebook, "Tab 3");

    gtk_main();

	return 0;
}

void create_new_tab(GtkWidget *notebook, char *text)
{
    GtkWidget *scrolledwindow;
    GtkWidget *browser;
    GtkWidget *label;
    GtkWidget *tabHbox;
    GtkWidget *btnClose;

    scrolledwindow = gtk_scrolled_window_new (NULL, NULL);    
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow),
                                    GTK_POLICY_NEVER, GTK_POLICY_NEVER);
    gtk_widget_show(scrolledwindow);

    browser = gtk_moz_embed_new();
    gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW(scrolledwindow), browser);
    gtk_widget_show(browser);

    label = gtk_label_new (text);
    gtk_widget_show (label);

    tabHbox = gtk_hbox_new(FALSE, 2);
    btnClose = gtk_button_new();
    gtk_widget_set_size_request(GTK_WIDGET(btnClose), 16, 16);
    gtk_container_add(GTK_CONTAINER(btnClose), gtk_image_new_from_stock(GTK_STOCK_CLOSE, GTK_ICON_SIZE_MENU));
    gtk_widget_show_all (btnClose);
    gtk_button_set_relief(GTK_BUTTON(btnClose), GTK_RELIEF_NONE);

    gtk_box_pack_start(GTK_BOX(tabHbox), label, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(tabHbox), btnClose, FALSE, FALSE, 0);

    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), scrolledwindow, tabHbox);

    g_signal_connect (GTK_WIDGET (btnClose), "clicked", G_CALLBACK(close_eventhandler), scrolledwindow);
}
